
"""
Illustrates the use of single or double loops to index
a range of values in the image using the ImageDraw module
"""

from PIL import Image, ImageDraw

im = Image.new('RGB', (300,300))

draw = ImageDraw.Draw(im)

## this paints four lines, 2 horizontal
##2 vertical
for i in range(300):
    draw.point((20,i), fill=(256,256,256))
    draw.point((i,20), fill=(256,256,256))
    draw.point((280,i), fill=(256,256,256))
    draw.point((i,280), fill=(256,256,256))

## this paints a single diagonal line
for i in range(300):
    draw.point((i,i), fill=(0,0,256))
    
## this paints the whole image, changes all the
## pixels in it    
for i in range(300):
    for j in range(300):
        draw.point((i,j), fill=(256,0,0))
        
        
## this paints two squares in the image, top left and
## bottom right        
## changes the colors in these squares        
        
## first top left
for x in range(150): ## x halfway
    for y in range(150): ## y halfway
        draw.point((x,y), fill = (0,0,256)) ##color blue

## second, bottom right
for x in range(150,300): ## x halfway
    for y in range(150,300): ## y halfway
        draw.point((x,y), fill = (0,256,0)) ##color green
        
im.show()

