"""
Loops
Loops
and more loops!

while loops
   - when end condition is not deterministic
   - easy to use for iterating over numbers 
   (you can use for indexing lists, chars in strings)


for loops

   iterate over items in a list
   good for printing the items (but not for changing them)
   
   
   iterate over indices of items in a list (using range)
   
Single loop or double loop?

   If you can do the computation with a single pass 
   then a single loop is enough: do I look one item
   or items side by side in a list ([i],[i+1]), I only
   need a single loop
   
   Double loop: If you need to look at pairs of values,
   or values in two dimensions (like in lists of lists),
   you need a double loop

Break vs continue

   Break: will break out of a loop (only the inner loop)
   skipping all steps 
   
   Continue: will skip all instructions after the 
   continue for the current iteration of a loop without
   breaking from a loop
   
   If you have a double loop, be careful which loop you are breaking from
   
   for ...
      for ...
      break
      
   breaks from inner loop, but the outer loop goes on
   
   for ...
      for ...
   break
   
   breaks from the outer loop
   
   Return: Return from a function acts like a break, 
   as soon as a return is executed, it stops all processing
   including all loops and returns a value.
   
"""

##This shows that return breaks from any loop

def exit_from_loop():
    for i in range(6):
        for j in range(6):
            print (i,j, end=" ")
            if j == 3:
                return
        print ()   


sumval = 0
for i in range(100):
    sumval += i
print (sumval)

## this shows that you must index a list to change the values in it
squares = list(range(10))
for i in range(len(squares)):
    squares[i]= squares[i]**2
print (squares)    


## this illustrates break, how breaking the loop stops it
## at exactly the given point
for i in range(10):
    print ("---",i)
    if i == 3:
        break
    print ("***", i**i)
    
    
## this shows a potential infinite loop with a break value
## don't use this metho in general, unless you really know
## for sure that your loop will end (why not use that condition
## in the while loop in that case)    
i = 0    
while True:
    print(i, flush=True)
    if i == 10:
        break
    i += 1
    
## this illustrates that this break only breaks from
## the inner loop, the outer loop continutes to execute    
for i in range(6):
    for j in range(6):
        print (i,j, end=" ")
        if j == 3:
            break
    print ()
    

## this illustrates continue will skip the print statement
## with ***, but will not stop the loop    
for i in range(10):
    print ("---",i)
    
    if i == 3:
        continue
    
    print ("***", i**i)
